/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.batch.planner.model.impl;

import com.liferay.batch.planner.model.BatchPlannerMapping;
import com.liferay.batch.planner.model.BatchPlannerPolicy;
import com.liferay.batch.planner.service.BatchPlannerMappingLocalServiceUtil;
import com.liferay.batch.planner.service.BatchPlannerPolicyLocalServiceUtil;
import com.liferay.portal.kernel.exception.PortalException;

import java.util.List;

/**
 * @author Igor Beslic
 */
public class BatchPlannerPlanImpl extends BatchPlannerPlanBaseImpl {

	@Override
	public BatchPlannerPolicy fetchBatchPlannerPolicy(String name) {
		return BatchPlannerPolicyLocalServiceUtil.fetchBatchPlannerPolicy(
			getBatchPlannerPlanId(), name);
	}

	@Override
	public List<BatchPlannerMapping> getBatchPlannerMappings() {
		return BatchPlannerMappingLocalServiceUtil.getBatchPlannerMappings(
			getBatchPlannerPlanId());
	}

	@Override
	public List<BatchPlannerPolicy> getBatchPlannerPolicies() {
		return BatchPlannerPolicyLocalServiceUtil.getBatchPlannerPolicies(
			getBatchPlannerPlanId());
	}

	@Override
	public BatchPlannerPolicy getBatchPlannerPolicy(String name)
		throws PortalException {

		return BatchPlannerPolicyLocalServiceUtil.getBatchPlannerPolicy(
			getBatchPlannerPlanId(), name);
	}

}